#if BX_INSTRUMENTATION
   void bx_instr_cnear_branch(Bit32u new_eip);
   void bx_instr_ucnear_branch(Bit32u new_eip);
   void bx_instr_far_branch(Bit32u new_cs, Bit32u new_eip);
   void bx_instr_opcode_byte1(Bit8u);
   void bx_instr_opcode_byte2(Bit8u);
#  define BX_INSTR_CNEAR_BRANCH(new_eip)       bx_instr_cnear_branch(new_eip)
#  define BX_INSTR_UCNEAR_BRANCH(new_eip)      bx_instr_ucnear_branch(new_eip)
#  define BX_INSTR_FAR_BRANCH(new_cs, new_eip) bx_instr_far_branch(new_cs, new_eip)

#  define BX_INSTR_OPCODE_BYTE1(b)             bx_instr_opcode_byte1(b)
#  define BX_INSTR_OPCODE_BYTE2(b)             bx_instr_opcode_byte2(b)

#  define BX_INSTR_OPCODE_G1EbIb(nnn)          bx_instr_opcode_g1ebib(nnn)
#  define BX_INSTR_OPCODE_G1EvIv(nnn)          bx_instr_opcode_g1eviv(nnn)
#  define BX_INSTR_OPCODE_G1EvIb(nnn)          bx_instr_opcode_g1evib(nnn)

#  define BX_INSTR_OPCODE_G2EbIb(nnn)          bx_instr_opcode_g2ebib(nnn)
#  define BX_INSTR_OPCODE_G2EvIb(nnn)          bx_instr_opcode_g2evib(nnn)
#  define BX_INSTR_OPCODE_G2Eb1(nnn)           bx_instr_opcode_g2eb1(nnn)
#  define BX_INSTR_OPCODE_G2Ev1(nnn)           bx_instr_opcode_g2ev1(nnn)
#  define BX_INSTR_OPCODE_G2EbCL(nnn)          bx_instr_opcode_g2ebcl(nnn)
#  define BX_INSTR_OPCODE_G2EvCL(nnn)          bx_instr_opcode_g2evcl(nnn)

#  define BX_INSTR_OPCODE_G3Eb(nnn)            bx_instr_opcode_g3eb(nnn)
#  define BX_INSTR_OPCODE_G3Ev(nnn)            bx_instr_opcode_g3ev(nnn)

#  define BX_INSTR_OPCODE_G4(nnn)              bx_instr_opcode_g4(nnn)

#  define BX_INSTR_OPCODE_G5(nnn)              bx_instr_opcode_g5(nnn)

#  define BX_INSTR_OPCODE_G6(nnn)              bx_instr_opcode_g6(nnn)

#  define BX_INSTR_OPCODE_G7(nnn)              bx_instr_opcode_g7(nnn)

#  define BX_INSTR_OPCODE_G8EvIb(nnn)          bx_instr_opcode_g8evib(nnn)
#else
#  define BX_INSTR_CNEAR_BRANCH(new_eip)
#  define BX_INSTR_UCNEAR_BRANCH(new_eip)
#  define BX_INSTR_FAR_BRANCH(new_cs, new_eip)
#  define BX_INSTR_OPCODE_BYTE1(b)
#  define BX_INSTR_OPCODE_BYTE2(b)
#  define BX_INSTR_OPCODE_G1EbIb(nnn)
#  define BX_INSTR_OPCODE_G1EvIv(nnn)
#  define BX_INSTR_OPCODE_G1EvIb(nnn)
#  define BX_INSTR_OPCODE_G2EbIb(nnn)
#  define BX_INSTR_OPCODE_G2EvIb(nnn)
#  define BX_INSTR_OPCODE_G2Eb1(nnn)
#  define BX_INSTR_OPCODE_G2Ev1(nnn)
#  define BX_INSTR_OPCODE_G2EbCL(nnn)
#  define BX_INSTR_OPCODE_G2EvCL(nnn)
#  define BX_INSTR_OPCODE_G3Eb(nnn)
#  define BX_INSTR_OPCODE_G3Ev(nnn)
#  define BX_INSTR_OPCODE_G4(nnn)
#  define BX_INSTR_OPCODE_G5(nnn)
#  define BX_INSTR_OPCODE_G6(nnn)
#  define BX_INSTR_OPCODE_G7(nnn)
#  define BX_INSTR_OPCODE_G8EvIb(nnn)
#endif
