class bx_memory_c {

public:
  Bit8u   *vector;
  size_t  len;
  size_t  megabytes;  // (len in Megabytes)

  bx_memory_c(void);
  bx_memory_c(size_t memsize);
  ~bx_memory_c(void);
  void    init_memory(int memsize);
  void    read_physical(Bit32u addr, unsigned len, void *data);
  void    write_physical(Bit32u addr, unsigned len, void *data);
  void    load_ROM(const char *path, Bit32u romaddress);
  Bit32u  get_memory_in_k(void);
  };

#if BX_PROVIDE_CPU_MEMORY==1
extern bx_memory_c    bx_mem;
#endif

void bx_dbg_fetch_mem(Bit32u addr, unsigned len, Bit8u *buf);
